#ifndef __LIMITS__H
#define __LIMITS__H

#define CHAR_BIT      8
#define SCHAR_MIN (-128)
#define SCHAR_MAX   127
#define UCHAR_MAX   0xff

#define CHAR_MIN SCHAR_MIN
#define CHAR_MAX SCHAR_MAX

#define SHRT_MIN  (-32768)
#define SHRT_MAX    32767
#define USHRT_MAX   0xffff

#define INT_MIN (-2147483647 - 1)
#define INT_MAX   2147483647
#define UINT_MAX  0xffffffff

#define LONG_MIN  INT_MIN
#define LONG_MAX  INT_MAX
#define ULONG_MAX UINT_MAX

#define I8_MIN  SCHAR_MIN
#define I8_MAX  SCHAR_MAX
#define UI8_MAX UCHAR_MAX

#define I16_MIN  SHRT_MIN
#define I16_MAX  SHRT_MAX
#define UI16_MAX USHRT_MAX

#define I32_MIN  INT_MIN
#define I32_MAX  INT_MAX
#define UI32_MAX UINT_MAX

#endif //!__LIMITS__H