#include "../../include/GPU/gpu.hpp"
#include <PSX/File/Processor/file_processor.hpp>
#include <PSX/GPU/gpu.hpp>

#ifdef JABYENGINE_PAL
    #include "splash_image_pal_boot.hpp"
#else
    #include "splash_image_ntsc_boot.hpp"
#endif //JABYENGINE_PAL

namespace GPU {
    void display_logo() {
        // Upload SplashScreen picture
        auto state = FileProcessor::create(reinterpret_cast<const uint32_t*>(SplashScreen), SimpleTIM(32, 0, 0, 0));
        while(state.process((sizeof(SplashScreen)/sizeof(uint32_t))));

        Display::enable();
    }

    void setup() {
        GP1.write(Command::GP1::Reset());
        Screen::configurate();
        Screen::exchange_buffer_and_display();
        
        GPU::wait_ready_for_CMD();
        quick_fill_fast(Color24::Black(), PositionU16(32, 0), SizeU16(Display::Width, Display::Height));
    }
}