@echo off
setlocal EnableDelayedExpansion
rem build_all [clean] [recommended|windows|linux]

call .config_build_all/recommended.bat
IF NOT "%~2" == "" (
    set config_path=.config_build_all/%~2.bat
    IF exist "!config_path!" (
        call !config_path!
    ) ELSE (
        @echo "Configuration !config_path! not found"
        exit -1
    )
)

set projects=%bin_projects%
set linux_projects=%bin_linux_projects%
set build_type=build
set cur_dir=%cd%

IF NOT "%~1" == "" (
    IF "%~1" == "clean" (
        set build_type=clean
        set projects=%projects% %clean_projects%
        set linux_projects=%linux_projects% %clean_projects_linux%
    ) ELSE (
        set build_type=%~1
    )
)

for %%a in (%projects%) do (
    call .\run_cargo %%a %build_type% release windows
    cd %cur_dir%
)

for %%a in (%linux_projects%) do (
    call .\run_cargo %%a %build_type% release linux
    cd %cur_dir%
)