use super::super::types::OverlaySlot;
use tool_helper::{Error, Output};

pub fn write(output: &mut Output, overlay_desc: &Vec<OverlaySlot>) -> Result<(), Error> {
    if !overlay_desc.is_empty() {
        write!(output, "OVERLAYSECTION = ")?;

        for slot in overlay_desc {
            for overlay in &slot.sections {
                write!(output, ".{} ", overlay.name)?;
            }
        }
        
        writeln!(output, "")?;
    }

    Ok(())
}