use super::{file_writer::{SectorWriter}, types::{CDDesc, Error, layout::Layout}};

pub mod psx;
pub mod builder;

pub type LengthCalculatorFunction = fn(&Layout) -> LengthInfo;
pub type LbaCalculatorFunction    = fn(&mut CDDesc);
pub type ImageEncoderFunction     = fn(&CDDesc, &mut dyn SectorWriter) -> Result<(), Error>;

pub struct LengthInfo {
    pub bytes:   Option<usize>,
    pub sectors: usize,
}

pub struct EncodingFunctions {
    pub length_calculator: LengthCalculatorFunction,
    pub lba_calculator:    LbaCalculatorFunction,
    pub encoder:           ImageEncoderFunction
}