use super::Error;
use lz4::EncoderBuilder;

pub fn lz4(data: &Vec<u8>, compression_level: u32) -> Result<Vec<u8>, Error> {
    let mut lz4_encoder = EncoderBuilder::new().level(compression_level).build(Vec::<u8>::new())?;
    
    std::io::copy(&mut&data[..], &mut lz4_encoder)?;
    let (output, result) = lz4_encoder.finish();

    match result {
        Ok(()) => Ok(output),
        Err(error) => Err(Error::from_error(error))
    }
}